#include <stdio.h>
#include "mv.h"

/* 
 * This version includes an extra index vector; the intent here is to
 * generate a "good" value for the cache, and use ka to select the
 * rows in this "better" order.  Computing ka is hard though; the
 * code currently in here is not what you want. 
 *
 * The code here for ka is particularly bad.  One possible change to ka:
 * have it contain the row value of the next row that is NOT consequtive.
 * That would reduce the amount of extraneous memory traffic.
 */
void mv_( ia, ja, ka,  a, x, y, n_ptr )
int    *ia, *ja, *ka, *n_ptr;
double *a, *x, *y;
{
    double     sum;
    int        i, jrow,j,ncol,shift,n=*n_ptr, row;

    /* x    = x + shift; */ 
    shift = 1; /* shift for Fortran start by 1 indexing */
    x = x - shift;
    for ( i=0; i<n; i++ ) {
	row  = ka[i];
	jrow = ia[row];
	ncol = ia[row+1] - jrow;
	jrow = jrow - shift;
	sum  = 0.0;
	/* while (ncol--) sum += *v++ * x[*ja++]; */
	for ( j=0; j<ncol; j++) {
	    sum += a[jrow]*x[ja[jrow]]; jrow++;
	}
	y[row] = sum;
    }
}

int mvextra_( ia, ja, a, n_ptr )
int *ia, *ja, *n_ptr;
double *a;
{
    return *n_ptr + 1;
}

void mvsetup_( ia, ja, ka, a, n_ptr )
int *ia, *ja, *ka, *n_ptr;
double *a;
{
    int i, j,  n = *n_ptr, *used, jrow, ncol, col, cnt, kcnt, row;

    /* Order the rows by ones used first */
    used = (int *)malloc( n * sizeof(int) );
    if (!used) {
	fprintf( stderr, "Could not allocated %d in setup\n", n );
	exit( 1 );
    }
    for (i=0; i<n; i++) used[i] = 0;

    cnt  = 0;
    kcnt = 0;
    /* Greedy algorithm for collecting elements */
    row = 0;
    for (i=0; i<n; i++) {
	jrow = ia[row];
	ncol = ia[row+1] - jrow;
	for (j=0; j<ncol; j++) {
	    col = ja[jrow+j];
	    if (!used[col]) {
		used[col] = 1;
		ka[cnt++] = col;
	    }
	}
	/* It might be better to sort these by cache page or other
	   memory-sensitive approach */
	row = ka[kcnt++] - 1;
    }
    if (cnt < n) {
	for (i=0; i<n; i++) {
	    if (!used[i]) {
		ka[cnt++] = i;
		if (cnt >= n) break;
	    }
	}
    }
    
    free( used );
}

void mvname_( str, ln )
char *str;
int  ln;
{
    strncpy( str, "C AIJ with greedy permuted row ordering", ln - 1 );
}

#ifndef FLAGS
#define FLAGS "Unknown"
#endif
void mvflags_(str, ln )
char *str;
int  ln;
{
    strncpy( str, FLAGS, ln - 1 );
}
